//+------------------------------------------------------------------+
//|                                                  iChannel_v2.mq4 |
//|                                                           NoName |
//+------------------------------------------------------------------+
//|iChannel_v2:                                                      |
//| -      Open-Close.   |
//|   Mode=1 -   High-Low;                                   |
//|   Mode=2 -   Open-Close;                                 |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 5
//---
#property indicator_color1 Yellow
#property indicator_width1 2
//---
#property indicator_color2 Yellow
#property indicator_width2 2
//---
#property indicator_color3 Blue
//---
#property indicator_color4 LightBlue
#property indicator_style4 STYLE_DOT
//---
#property indicator_color5 LightBlue
#property indicator_style5 STYLE_DOT

//---- input parameters
extern int       Cbar   = 60;
extern int       Delta  = 4;
//  :
// 1 - High-Low;
// 2 - Open-Close;
extern int       Mode   = 1;
//---- buffers
double UpperLine[];
double LowerLine[];
double MiddleLine[];
double DeltaUp[];
double DeltaLow[];

double LowestValue;
double HighestValue;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(0,UpperLine);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(1,LowerLine);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,MiddleLine);
   SetIndexStyle(3,DRAW_LINE,STYLE_DOT);
   SetIndexBuffer(3,DeltaUp);
   SetIndexStyle(4,DRAW_LINE,STYLE_DOT);
   SetIndexBuffer(4,DeltaLow);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if (Mode != 1 && Mode != 2) {
      Comment("   Mode!");
      return(0);
   }
   
   int    counted_bars=IndicatorCounted();
//----
   int limit;
   double HCh;
   double LCh;
   double MidCh;
   
     if(counted_bars>0) counted_bars--;
     limit=Bars-counted_bars;
  
     for(int i=0; i<limit; i++)
       {
        
         if (Mode == 1) {
            HCh = High[iHighest(NULL,0,MODE_HIGH,Cbar,i)];
            LCh = Low[iLowest(NULL,0,MODE_LOW,Cbar,i)];
            MidCh=NormalizeDouble((HCh+LCh)/2,Digits);
         }
         
         if (Mode == 2) {
            GetValues(Cbar, i);
            HCh = HighestValue;
            LCh = LowestValue;
            MidCh=NormalizeDouble((HCh+LCh)/2,Digits);
         }
         
         UpperLine[i] = HCh;
         LowerLine[i] = LCh;
         MiddleLine[i]= MidCh;
         
         DeltaUp[i]   = HCh - Delta * Point;
         DeltaLow[i]  = LCh + Delta * Point;
       }
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator GetValues() function                            |
//+------------------------------------------------------------------+
void GetValues(int count, int shift) {

   double HighestPrice=0.0;
   double LowestPrice=999999999.9;
   double tmp_high;
   double tmp_low;

      for (int i=shift+count; i>=shift; i-- ) {
      
         if ( Close[i] >= Open[i] ) {tmp_high = Close[i]; tmp_low = Open[i]; }
         if ( Close[i] <= Open[i] ) {tmp_high = Open[i]; tmp_low = Close[i]; }
      
         if (tmp_high >= HighestPrice) HighestPrice = tmp_high;
         if (tmp_low  <= LowestPrice)  LowestPrice  = tmp_low;
      }
   HighestValue = HighestPrice;
   LowestValue  = LowestPrice;
    
}

//+------------------------------------------------------------------+